<template>
  <v-card
    v-bind="$attrs"
    :class="classes"
    style="width: 100%"
  >
    <!-- <div class="d-flex grow flex-wrap title-header-modify primary pa-2">
      <h2>{{ this.title }}</h2>
    </div> -->
    <div class="d-flex grow flex-wrap mb-2">
      <v-sheet
        :color="color"
        :max-height="icon ? 90 : undefined"
        :width="icon ? 'auto' : '100%'"
        class="text-right mt-0 mr-0"
        dark
      >
        <div
          v-if="text"
          class="headline font-weight-thin"
          v-text="text"
        />
        <v-btn
          v-show="isShow0"
          :color="color0"
          class="mr-1"
          @click="action0()"
        >
          <span v-if="!isMobile()">
            {{ text0 }}
          </span>
          <v-icon>
            {{ icon0 }}
          </v-icon>
        </v-btn>

        <v-btn
          v-show="disabled1"
          :color="color1"
          class="mr-1"
          @click="action1()"
        >
          <span v-if="!isMobile()">
            {{ text1 }}
          </span>
          <v-icon>
            {{ icon1 }}
          </v-icon>
        </v-btn>
        <v-btn
          v-show="disabled2"
          :color="color2"
          class="mr-1"
          @click="action2()"
        >
          <span v-if="!isMobile()">
            {{ text2 }}
          </span>
          <v-icon>
            {{ icon2 }}
          </v-icon>
        </v-btn>
        <v-btn
          v-show="disabled3"
          :color="color3"
          class="mr-1"
          @click="action3()"
        >
          <span v-if="!isMobile()">
            {{ text3 }}
          </span>
          <v-icon>
            {{ icon3 }}
          </v-icon>
        </v-btn>
        <v-btn
          v-show="disabledHome"
          :color="colorHome"
          class="mr-1"
          @click="actionHome()"
        >
          <span v-if="!isMobile()">
            {{ textHome }}
          </span>
          <v-icon>
            {{ iconHome }}
          </v-icon>
        </v-btn>
      </v-sheet>
    </div>

    <slot />

    <template v-if="$slots.actions">
      <v-divider class="mt-2" />

      <v-card-actions class="pb-0">
        <slot name="actions" />
      </v-card-actions>
    </template>
  </v-card>
</template>

<script>
  export default {
    name: 'MaterialCard',

    props: {
      avatar: {
        type: String,
        default: '',
      },
      color: {
        type: String,
        default: '#FFFFFF',
      },
      icon: {
        type: String,
        default: undefined,
      },
      image: {
        type: Boolean,
        default: false,
      },
      text: {
        type: String,
        default: '',
      },
      title: {
        type: String,
        default: '',
      },
      text0: {
        type: String,
        default: 'Chốt SK',
      },
      text1: {
        type: String,
        default: 'Thêm',
      },
      icon0: {
        type: String,
        default: 'add',
      },
      color0: {
        type: String,
        default: 'color0',
      },
      icon1: {
        type: String,
        default: 'add',
      },
      color1: {
        type: String,
        default: 'primary',
      },
      text2: {
        type: String,
        default: 'Xóa',
      },
      icon2: {
        type: String,
        default: 'close',
      },
      color2: {
        type: String,
        default: 'error',
      },
      text3: {
        type: String,
        default: 'Nhập',
      },
      icon3: {
        type: String,
        default: 'save_alt',
      },
      color3: {
        type: String,
        default: 'warning',
      },
      disabled1: {
        type: Boolean,
        default: false,
      },
      disabled2: {
        type: Boolean,
        default: false,
      },
      disabled3: {
        type: Boolean,
        default: false,
      },
      isShow0: {
        type: Boolean,
        default: false,
      },
      iconHome: {
        type: String,
        default: 'home',
      },
      colorHome: {
        type: String,
        default: 'light-gray',
      },
      disabledHome: {
        type: Boolean,
        default: true,
      },
      textHome: {
        type: String,
        default: 'Home',
      },
    },

    computed: {
      classes () {
        if (
          /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(
            navigator.userAgent,
          )
        ) {
          return 'v-card--material pa-2'
        } else {
          return 'v-card--material pa-3'
        }
        // return {
        //   'v-card--material--has-heading': this.hasHeading,
        // }
      },
      hasHeading () {
        return Boolean(this.$slots.heading || this.title || this.icon)
      },
      hasAltHeading () {
        return Boolean(this.$slots.heading || (this.title && this.icon))
      },
      classVcard () {
        if (
          /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(
            navigator.userAgent,
          )
        ) {
          return 'v-card--material pa-1'
        } else {
          return 'v-card--material pa-3'
        }
      },
    },
    methods: {
      // getClassVcard () {
      //   if (
      //     /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(
      //       navigator.userAgent,
      //     )
      //   ) {
      //     return 'v-card--material pa-1'
      //   } else {
      //     return 'v-card--material pa-3'
      //   }
      // },
      isMobile () {
        if (
          /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(
            navigator.userAgent,
          )
        ) {
          return true
        } else {
          return false
        }
      },
      action1 ($event) {
        this.$emit('action-1')
      },
      action2 ($event) {
        this.$emit('action-2')
      },
      action3 ($event) {
        this.$emit('action-3')
      },
      backList ($event) {
        this.$emit('back-list')
      },
      action0 ($event) {
        this.$emit('action-0')
      },
      actionHome ($event) {
        this.$emit('action-home')
      },

    },
  }
</script>

<style lang="sass">
.v-card--material
  &__avatar
    position: relative
    top: -64px
    margin-bottom: -32px

    &__heading
      position: relative
      top: -40px
      transition: .3s ease
      z-index: 1
</style>
